# FCommand
Date: 2018-12-06

com.massivecraft.factions.cmd

## Class FCommand

- java.lang.Object
- - com.massivecraft.factions.zcore.MCommand<SaberFactions>
  - - com.massivecraft.factions.cmd.FCommand

Direct Known Subclasses:
  CmdAdmin, CmdAHome, CmdAnnounce, CmdAutoClaim, CmdBan, CmdBanlist, CmdBanner, CmdBoom, CmdBypass, CmdChat, CmdChatSpy, CmdCheckpoint, CmdChest, CmdClaim, CmdClaimAt, CmdClaimLine, CmdColeader, CmdConfig, CmdConvert, CmdCoords, CmdCreate, CmdDeinvite, CmdDelFWarp, CmdDescription, CmdDisband, CmdFly, CmdFocus, CmdFWarp, CmdGetVault, CmdHelp, CmdHome, CmdInspect, CmdInvite, CmdJoin, CmdKick, CmdKillHolograms, CmdLeave, CmdList, CmdLock, CmdLogins, CmdLowPower, CmdMap, CmdMapHeight, CmdMod, CmdModifyPower, CmdMoney, CmdMoneyBalance, CmdMoneyDeposit, CmdMoneyTransferFf, CmdMoneyTransferFp, CmdMoneyTransferPf, CmdMoneyWithdraw, CmdNear, CmdOpen, CmdOwner, CmdOwnerList, CmdPaypalSee, CmdPaypalSet, CmdPeaceful, CmdPerm, CmdPermanent, CmdPermanentPower, CmdPower, CmdPowerBoost, CmdReload, CmdRules, CmdSafeunclaimall, CmdSaveAll, CmdSB, CmdSeeChunk, CmdSetBanner, CmdSetDefaultRole, CmdSetFWarp, CmdSethome, CmdSetMaxVaults, CmdShow, CmdShowClaims, CmdShowInvites, CmdStatus, CmdStealth, CmdStuck, CmdTag, CmdTitle, CmdTnt, CmdTntFill, CmdToggleAllianceChat, CmdTop, CmdTpBanner, CmdUnban, CmdUnclaim, CmdUnclaimall, CmdUpgrades, CmdVault, CmdVersion, CmdWarunclaimall, FCmdRoot, FPromoteCommand, FRelationCommand

    public abstract class FCommand
    extends MCommand<SaberFactions>

### Field Summary

Fields
`boolean` `disableOnLock`
`FPlayer` `fme`
`boolean` `isMoneyCommand`
`Faction` `myFaction`
`static java.text.SimpleDateFormat` `sdf`
`boolean` `senderMustBeAdmin`
`boolean` `senderMustBeColeader`
`boolean` `senderMustBeMember`
`boolean` `senderMustBeModerator`

### Fields inherited from class com.massivecraft.factions.zcore.MCommand

`aliases, allowNoSlashAccess, args, commandChain, errorOnToManyArgs, helpLong, me, optionalArgs, p, permission, requiredArgs, sender, senderIsConsole, senderMustBePlayer, subCommands, visibility`

### Constructor Summary

Constructors
Constructor and Description
`FCommand()`

### Method Summary

All Methods Instance Methods Concrete Methods
`FPlayer` `argAsBestFPlayerMatch(int idx)`
`FPlayer` `argAsBestFPlayerMatch(int idx, FPlayer def)`
`FPlayer` `argAsBestFPlayerMatch(int idx, FPlayer def, boolean msg)`
`Faction` `argAsFaction(int idx)`
`Faction` `argAsFaction(int idx, Faction def)`
`Faction` `argAsFaction(int idx, Faction def, boolean msg)`
`FPlayer` `argAsFPlayer(int idx)`
`FPlayer` `argAsFPlayer(int idx, FPlayer def)`
`FPlayer` `argAsFPlayer(int idx, FPlayer def, boolean msg)`
`boolean` `assertHasFaction()`
`boolean` `assertMinRole(Role role)`
`boolean` `canAffordCommand(double cost, java.lang.String toDoThis)`
`boolean` `canIAdministerYou(FPlayer i, FPlayer you)`
`void` `doWarmUp(FPlayer player, WarmUpUtil.Warmup warmup, TL translationKey, java.lang.String action, java.lang.Runnable runnable, long delay)`
`void` `doWarmUp(WarmUpUtil.Warmup warmup, TL translationKey, java.lang.String action, java.lang.Runnable runnable, long delay)`
`void` `execute(org.bukkit.command.CommandSender sender, java.util.List<java.lang.String> args, java.util.List<MCommand<?>> commandChain)`
`boolean` `isEnabled()`
`boolean` `payForCommand(double cost, java.lang.String toDoThis, java.lang.String forDoingThis)`
`boolean` `payForCommand(double cost, TL toDoThis, TL forDoingThis)`
`FPlayer` `strAsBestFPlayerMatch(java.lang.String name, FPlayer def, boolean msg)`
`Faction` `strAsFaction(java.lang.String name, Faction def, boolean msg)`
`FPlayer` `strAsFPlayer(java.lang.String name, FPlayer def, boolean msg)`
`boolean` `validSenderType(org.bukkit.command.CommandSender sender, boolean informSenderIfNot)`

### Methods inherited from class com.massivecraft.factions.zcore.MCommand

`addSubCommand, argAsBestPlayerMatch, argAsBestPlayerMatch, argAsBestPlayerMatch, argAsBool, argAsBool, argAsDouble, argAsDouble, argAsInt, argAsInt, argAsPlayer, argAsPlayer, argAsPlayer, argAsString, argAsString, argIsSet, execute, getHelpShort, getToolTips, getToolTips, getUsageTranslation, getUseageTemplate, getUseageTemplate, getUseageTemplate, msg, msg, perform, replaceFactionTags, replaceFPlayerTags, sendFancyMessage, sendFancyMessage, sendMessage, sendMessage, setHelpShort, strAsBestPlayerMatch, strAsBool, strAsDouble, strAsInt, strAsPlayer, validArgs, validArgs, validCall, validSenderPermissions`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### sdf

    public static final java.text.SimpleDateFormat sdf

#### disableOnLock

    public boolean disableOnLock

#### fme

    public FPlayer fme

#### myFaction

    public Faction myFaction

#### senderMustBeMember

    public boolean senderMustBeMember

#### senderMustBeModerator

    public boolean senderMustBeModerator

#### senderMustBeAdmin

    public boolean senderMustBeAdmin

#### senderMustBeColeader

    public boolean senderMustBeColeader

#### isMoneyCommand

    public boolean isMoneyCommand

### Constructor Detail

#### FCommand

    public FCommand()

### Method Detail

#### execute

    public void execute(org.bukkit.command.CommandSender sender,
                        java.util.List<java.lang.String> args,
                        java.util.List<MCommand<?>> commandChain)

Overrides:
  `execute` in class `MCommand<SaberFactions>`

#### isEnabled

    public boolean isEnabled()

Overrides:
  `isEnabled` in class `MCommand<SaberFactions>`

#### validSenderType

    public boolean validSenderType(org.bukkit.command.CommandSender sender,
                                   boolean informSenderIfNot)

Overrides:
  `validSenderType` in class `MCommand<SaberFactions>`

#### assertHasFaction

    public boolean assertHasFaction()

#### assertMinRole

    public boolean assertMinRole(Role role)

#### strAsFPlayer

    public FPlayer strAsFPlayer(java.lang.String name,
                                FPlayer def,
                                boolean msg)

#### argAsFPlayer

    public FPlayer argAsFPlayer(int idx,
                                FPlayer def,
                                boolean msg)

#### argAsFPlayer

    public FPlayer argAsFPlayer(int idx,
                                FPlayer def)

#### argAsFPlayer

    public FPlayer argAsFPlayer(int idx)

#### strAsBestFPlayerMatch

    public FPlayer strAsBestFPlayerMatch(java.lang.String name,
                                         FPlayer def,
                                         boolean msg)

#### argAsBestFPlayerMatch

    public FPlayer argAsBestFPlayerMatch(int idx,
                                         FPlayer def,
                                         boolean msg)

#### argAsBestFPlayerMatch

    public FPlayer argAsBestFPlayerMatch(int idx,
                                         FPlayer def)

#### argAsBestFPlayerMatch

    public FPlayer argAsBestFPlayerMatch(int idx)

#### strAsFaction

    public Faction strAsFaction(java.lang.String name,
                                Faction def,
                                boolean msg)

#### argAsFaction

    public Faction argAsFaction(int idx,
                                Faction def,
                                boolean msg)

#### argAsFaction

    public Faction argAsFaction(int idx,
                                Faction def)

#### argAsFaction

    public Faction argAsFaction(int idx)

#### canIAdministerYou

    public boolean canIAdministerYou(FPlayer i,
                                     FPlayer you)

#### payForCommand

    public boolean payForCommand(double cost,
                                 java.lang.String toDoThis,
                                 java.lang.String forDoingThis)

#### payForCommand

    public boolean payForCommand(double cost,
                                 TL toDoThis,
                                 TL forDoingThis)

#### canAffordCommand

    public boolean canAffordCommand(double cost,
                                    java.lang.String toDoThis)

#### doWarmUp

    public void doWarmUp(WarmUpUtil.Warmup warmup,
                         TL translationKey,
                         java.lang.String action,
                         java.lang.Runnable runnable,
                         long delay)

#### doWarmUp

    public void doWarmUp(FPlayer player,
                         WarmUpUtil.Warmup warmup,
                         TL translationKey,
                         java.lang.String action,
                         java.lang.Runnable runnable,
                         long delay)